
#ifndef CS_H_
#define CS_H_

#include "osHandles.h"              // Includes all FreeRTOS Files
#include "./FreeRTOS/FreeRTOS.h"	// Includes for RTOS & Other services provided by it:
#include "./FreeRTOS/task.h"
#include "./FreeRTOS/queue.h"
#include "./FreeRTOS/semphr.h"
#include <stdlib.h>
#include <stdio.h>


typedef enum { sel_SD, sel_Flash, sel_MP3, sel_Nothing} CS_Signal;
void CS_Sel(CS_Signal s);
void CS_Init();

void CS_Sel(CS_Signal s)
{
	IOSET0 = (1 << 10); /* SD:    High to Deselect */
	IOSET0 = (1 << 12); /* Flash: High to Deselect */
	IOCLR1 = (1 << 29); /* MP3:   Low to Deselect */

	switch(s)
	{
		case sel_SD:	IOCLR0 = (1 << 10); break; /* Active Low = LOW to sel */
		case sel_Flash:	IOCLR0 = (1 << 12); break; /* Active Low = LOW to sel */
		case sel_MP3:	IOSET1 = (1 << 29); break; /* Active High = HIGH to sel */

		case sel_Nothing:
		default:
			break;
	}
}
void CS_Init()
{
	IODIR0 |= (1 << 10); // SD: P0.10
	IODIR0 |= (1 << 12); // Flash: P0.12
	IODIR1 |= (1 << 29); // MP3: P1.29

	//OSHANDLES *osHandles = 0;
	//xSemaphoreTake((osHandles->lock.SPI),1000);

	CS_Sel(sel_Nothing);

	CS_Sel(sel_SD);
	vTaskDelay(1000);
	CS_Sel(sel_Flash);
	vTaskDelay(1000);
	CS_Sel(sel_MP3);
	vTaskDelay(1000);

	CS_Sel(sel_Nothing);
}

#endif /* CS_H_ */
