#include "mp3.hpp"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "stdlib.h"
#include "../osHandles.h"
#include "drivers/sta013.h"
#include "drivers/uart0.h"
#include "drivers/ssp_spi.h"
#include "fat/ff.h"
#include "fat/diskio.h"
#include "utils/rprintf.h"
#include "tasks/userInterface.hpp"
#include "utils/vector.hpp"
#include "CString.hpp"

void mp3Task(void* p)
{
	OSHANDLES *osHandles = (OSHANDLES*)p;
	VECTOR<cString> songNameVector;
	for(;;)
	{
		 char qBuffer[13];
		 if(xQueueReceive( osHandles->queue.songNameQueue, qBuffer, portMAX_DELAY))
		 {
			 cString songName = qBuffer;
			 songNameVector.push_back(songName);
			 while(xQueueReceive(osHandles->queue.songNameQueue, qBuffer, portMAX_DELAY))
			 {
				 songName = qBuffer;
				 if(songName == "done"){
					 break;
				 }
				 songNameVector.push_back(songName);
			 }
			// songNameVector.push_back(songName);
			 FIL myFile;
			 int ctrl;
			 char buff[512];
			 unsigned int bytesToRead = 512;
			 unsigned int bytesRead = 0;
			 unsigned int bytesStreamed = 0;

			 rprintf("VECTOR BACK:   %s\n\n", songNameVector.back().c_str());
			 rprintf("VECTOR FRONT:   %s\n\n", songNameVector.front().c_str());
			 while(1)
			 {
				 if(FR_OK != ( f_open(&myFile, songNameVector.front().c_str(), (FA_READ | FA_OPEN_EXISTING)))){
					 rprintf("COULD NOT OPEN FILE\n");
					 break;
				 }
				 while(FR_OK == (f_read(&myFile, buff, bytesToRead, &bytesRead)))
				 {
					 bytesStreamed = 0;
					 if(xSemaphoreTake(osHandles->lock.SPI, 3000))
					 {
						 SELECT_MP3_CS();
						 while(bytesStreamed < bytesRead) //have i streamed more data than i have?
						 {
							 if(STA013_NEEDS_DATA()){
								 rxTxByteSSPSPI(buff[bytesStreamed++]);
							 }
							 else{
								 vTaskDelay(2);
							 }
						 }
						 DESELECT_MP3_CS();
						 xSemaphoreGive(osHandles->lock.SPI);
					 }
					 if((bytesToRead != bytesRead)||(xQueueReceive(osHandles->queue.trackCTRL, &ctrl, 0) ))
					 {
						 if(ctrl == 1)
						 {
							//rotate right for next track
							 songNameVector.rotateRight();
							 break;
						 }
						 else if(ctrl == 2)
						 {
							 //rotate left previous track
							 songNameVector.rotateLeft();
							 break;
						 }
						 else
						 {
							 rprintf("WENT TO ELSE STATEMENT\n");
							 break;
						 }
					 }
				 }
			 }
		 }
	}
}
